import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { ShopGift, ShopGiftParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询礼品卡
 */
export async function pageShopGift(params: ShopGiftParam) {
  const res = await request.get<ApiResult<PageResult<ShopGift>>>(
    MODULES_API_URL + '/shop/shop-gift/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询礼品卡列表
 */
export async function listShopGift(params?: ShopGiftParam) {
  const res = await request.get<ApiResult<ShopGift[]>>(
    MODULES_API_URL + '/shop/shop-gift',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加礼品卡
 */
export async function addShopGift(data: ShopGift) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-gift',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
}

/**
 * 生成礼品卡
 */
export async function makeShopGift(data: ShopGift) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-gift/make',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改礼品卡
 */
export async function updateShopGift(data: ShopGift) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-gift',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除礼品卡
 */
export async function removeShopGift(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-gift/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除礼品卡
 */
export async function removeBatchShopGift(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-gift/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询礼品卡
 */
export async function getShopGift(id: number) {
  const res = await request.get<ApiResult<ShopGift>>(
    MODULES_API_URL + '/shop/shop-gift/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

export async function exportShopGift(ids?: number[]) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-gift/export',
    ids
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
